Вопрос по – Обновите триггер quartz.net через 15 минут, если работа не удалась, за исключением

13

Я искал ответ о том, как повторно выполнить задание через определенное количество времени, если задание выдает исключение. Я не вижу никакого простого способа сделать это.

если я установлю свой триггер так:

JobDetail job = new JobDetail("Download catalog", null, typeof(MyJob));
job .Durable = true;
Trigger trigger= TriggerUtils.MakeDailyTrigger(12, 0);
trigger.StartTimeUtc = DateTime.UtcNow;
trigger.Name = "trigger name";
scheduler.ScheduleJob(job , trigger);

И MyJob выглядит так:

public class MyJob : IJob
{
    public void Execute(JobExecutionContext context)
    {
        var service = new service();


        try
        {
            service.Download();
        }
        catch (Exception)
        {
            throw;
        }

    }
}

как сделать триггер для обновления / повторного запуска после того, как прошло 15 минут, если вызов service.Download () вызывает какое-то исключение?

Ваш Ответ

4   ответа
8

Я думаю, что правильный ответ - использовать JobListener, чтобы повторить задание, как описано здесь:http://thecodesaysitall.blogspot.cz/2012/03/quartz-candy-part-1.html.

В этом решении вы отделяете логику повторных попыток от самого Job, чтобы ее можно было использовать повторно.

Если вы реализуете логику повтора в задании, как предложено в других ответах, это должно быть реализовано снова в каждом задании.

Редактировать: Согласно записке Раманприта Сингха, лучшее решение может быть найденоВот: https://blog.harveydelaney.com/quartz-job-exception-retrying/

Error: User Rate Limit Exceededgithub.com/malmgren80/Quartz.Candy
Error: User Rate Limit Exceededblog.harveydelaney.com/quartz-job-exception-retrying
6

Я думаю, что единственный вариант, который у вас есть, это перехватить ошибку и попросить Quartz.net немедленно возобновить:

public class MyJob : IJob
{
    public void Execute(JobExecutionContext context)
    {
        var service = new service();

        try
        {
            service.Download();
        }
        catch (Exception ex)
        {
              JobExecutionException qe = new JobExecutionException(ex);
              qe.RefireImmediately = true;  // this job will refire immediately
              throw qe;  
        }
    }
}

Вы можете найти некоторую информациюВот а такжеВот.

UPDATE:

Я провел несколько тестов, и кажется, что вы можете запланировать новый триггер внутри выполняемой работы.
Вы можете попробовать что-то вроде этого:

public class MyJob : IJob
{
    public void Execute(JobExecutionContext context)
    {
        var service = new service();

        try
        {
            service.Download();
        }
        catch (Exception ex)
        {
            JobExecutionException qe = new JobExecutionException(ex);
            // qe.RefireImmediately = true;  // this job will refire immediately
            // throw qe;  
            OnErrorScheduleJob(context);

        }
    }

    private void OnErrorScheduleJob(JobExecutionContext context)
    {
        var jobOnError = context.Scheduler.GetJobDetail("ONERRORJOB", "ERROR");
        if (jobOnError == null)
        {
        JobDetail job = new JobDetail("ONERRORJOB", "ERROR", typeof(MyJob));
        job.Durable = false;
        job.Volatile = false;
        job.RequestsRecovery = false;

        SimpleTrigger trigger = new SimpleTrigger("ONERRORTRIGGER",
                        "ERROR",
                        DateTime.UtcNow.AddMinutes(15),
                        null,
                        1,
                        TimeSpan.FromMinutes(100));

        context.Scheduler.ScheduleJob(job, trigger);     
        }
    }
}
Error: User Rate Limit Exceeded mslot
Error: User Rate Limit Exceeded
Error: User Rate Limit Exceeded mslot
Error: User Rate Limit Exceeded
0
// don't forget to use @PersistJobDataAfterExecution without it, the jobExecutionContext will reset the value of count.     

SimpleTriggerImpl retryTrigger = new SimpleTriggerImpl();
    retryTrigger.setName("jobname");
    retryTrigger.setRepeatCount(0);
    retryTrigger.setJobKey(jobExecutionContext.getJobDetail().getKey());
    final Calendar cal = getCalendarInstance();
    cal.add(Calendar.MINUTE, 1); //retry after one minute
    retryTrigger.setStartTime(cal.getTime());
    try {
        jobExecutionContext.getScheduler().scheduleJob(retryTrigger);   // schedule the trigger
    } catch (SchedulerException ex) {
        logger.error("something went wrong", ex); 
    }
    JobExecutionException e2 = new JobExecutionException("retrying...");
    e2.refireImmediately();
    throw e2;
19

На самом деле, нет необходимости создавать новый JobDetail, как описано в LeftyX. Вы можете просто запланировать новый триггер, который подключен к JobDetail из текущего контекста.

public void Execute(JobExecutionContext context) {
    try {
        // code
    } catch (Exception ex) {
        SimpleTriggerImpl retryTrigger = new SimpleTriggerImpl(Guid.NewGuid().ToString());      
        retryTrigger.Description = "RetryTrigger";
        retryTrigger.RepeatCount = 0;
        retryTrigger.JobKey = context.JobDetail.Key;   // connect trigger with current job      
        retryTrigger.StartTimeUtc = DateBuilder.NextGivenSecondDate(DateTime.Now, 30);  // Execute after 30 seconds from now
        context.Scheduler.ScheduleJob(retryTrigger);   // schedule the trigger

        JobExecutionException jex = new JobExecutionException(ex, false);
        throw jex;
    }
}

Это менее подвержено ошибкам, чем создание нового JobDetail. Надеюсь, это поможет.

Похожие вопросы